<?php
/*
Plugin Name: Smsbox – Send SMS to WooCommerce customers & admins.
Plugin URI: http://www.smsbox.gr
Version: 2.0.0
Description: This extension will integrate SMS features into your WooCommerce store.
Author: Smsbox
Tested up to: 6.1.1
Author URI: http://www.smsbox.gr
Text Domain: smsbox
*/


if ( !defined( 'ABSPATH' ) ) exit; // Exit if accessed directly

if ( in_array( 'woocommerce/woocommerce.php', apply_filters( 'active_plugins', get_option( 'active_plugins' ) ) ) ) {
    error_reporting(E_ALL);
    if ( in_array( 'woocommerce_smsbox/smsbox.php', apply_filters( 'active_plugins', get_option( 'active_plugins' ) ) ) ) {
        if ( 'impossible_default_value_1234' === get_option( 'wp_smsbox_username', 'impossible_default_value_1234' ) ) {
            add_option('wp_smsbox_username','');
            add_option('wp_smsbox_password','');
            add_option('wp_smsbox_config');
        }
    }
    // load default methods
    add_action( 'admin_enqueue_scripts','load_assets');
    add_action('admin_post_add_smsbox', 'add_username_pass');
    add_action('admin_menu', 'Smsbox_setup_menu');

    add_action('add_meta_boxes','smsbox_meta_box');
    
    add_action( 'wp_ajax_smsbox_quick_sms_send_action', 'smsbox_quick_sms_send_action' );

    function Smsbox_setup_menu(){
        add_menu_page( 'Smsbox Plug-in', 'Smsbox', 'manage_options', 'woocommerce_smsbox', 'woocommerce_smsbox_init' ,'dashicons-email-alt' );
    }

    function smsbox_meta_box(){
        $screens = ['shop_order'];
        foreach ($screens as $screen) {
            add_meta_box('smsbox_meta_box_id',__('Smsbox SMS','woocommerce_smsbox'),'smsbox_box_html',$screen,'side');
        }
    }

    function smsbox_box_html(){
        global $post;
        $order = wc_get_order($post->ID);
        $recipient = '';

        if ($order) {
            // $country = $order->get_billing_country();
            // $message = apply_filters('webexpert_woocommerce_sms_default_message','');
            //$recipient = $this->webexpert_woocommerce_sms_get_recipeint($post->ID);
            // $recipient = $order->get_meta('_billing_phone'); // _billing_phone || _billing_cellphone
            $recipient = $order->get_billing_phone();
        }
        
        ?>         
            <div>
                <label>Recipient</label>
                <input id="quick-sms-recipient" name="smsbox_quick_sms_recipient" type="text" value="<?php echo $recipient; ?>">
            </div>    
            <div>
                <label id="quick-sms-text-label">SMS message</label>
                <textarea id="quick-sms-text" name="smsbox_quick_sms_text" class="input-text" cols="20" rows="5"></textarea>      
                <div id="quick-sms-message-counter">160 | <b>SMS: 1</b></div>
            </div>
            <div id="quick-sms-button-container">
                <button id="quick-sms-send-button" class="button button-primary" type="button">Send SMS</button>
            </div>
        <?php
        
    }

    // get credits
    function get_credits(){
        $url = 'http://www.smsbox.gr/httpapi/getbalance.php?username='.get_option( 'wp_smsbox_username' ).'&password='.get_option( 'wp_smsbox_password' );
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        $output = curl_exec($ch);
        curl_close($ch);

        $output_int = (int)$output;
        return $output_int;

    }

    function load_assets(){
        wp_enqueue_style( 'smsbox-style', plugins_url( 'assets/css/style.css', __FILE__ ), false, date( 'Ymd' ) );
        wp_enqueue_script( 'smsbox-script', plugins_url( 'assets/js/script.js', __FILE__ ), array( 'jquery' ), false, true );
        wp_localize_script( 'smsbox-script', 'smsbox_ajax_object', array( 'ajax_url' => admin_url( 'admin-ajax.php' )));
    }

    function add_username_pass() {
        if($_POST['wp_smsbox_username']!=''&& $_POST['wp_smsbox_password']!=''){
            $wp_smsbox_config = $_POST['wp_smsbox_config'];

            $wp_smsbox_config['admin_message_onhold']      = substr(sanitize_text_field($wp_smsbox_config['admin_message_onhold']),0,612);
            $wp_smsbox_config['admin_message_pending']      = substr(sanitize_text_field($wp_smsbox_config['admin_message_pending']),0,612);
            $wp_smsbox_config['admin_message_processing']      = substr(sanitize_text_field($wp_smsbox_config['admin_message_processing']),0,612);
            $wp_smsbox_config['admin_message_complete']      = substr(sanitize_text_field($wp_smsbox_config['admin_message_complete']),0,612);
            $wp_smsbox_config['admin_message_cancelled']      = substr(sanitize_text_field($wp_smsbox_config['admin_message_cancelled']),0,612);
            $wp_smsbox_config['admin_message_refunded']      = substr(sanitize_text_field($wp_smsbox_config['admin_message_refunded']),0,612);
            $wp_smsbox_config['admin_message_failed']      = substr(sanitize_text_field($wp_smsbox_config['admin_message_failed']),0,612);

            $wp_smsbox_config['customer_message_onhold']   = substr(sanitize_text_field($wp_smsbox_config['customer_message_onhold']),0,612);
            $wp_smsbox_config['customer_message_pending']   = substr(sanitize_text_field($wp_smsbox_config['customer_message_pending']),0,612);
            $wp_smsbox_config['customer_message_processing']   = substr(sanitize_text_field($wp_smsbox_config['customer_message_processing']),0,612);
            $wp_smsbox_config['customer_message_complete']   = substr(sanitize_text_field($wp_smsbox_config['customer_message_complete']),0,612);
            $wp_smsbox_config['customer_message_cancelled']   = substr(sanitize_text_field($wp_smsbox_config['customer_message_cancelled']),0,612);
            $wp_smsbox_config['customer_message_refunded']   = substr(sanitize_text_field($wp_smsbox_config['customer_message_refunded']),0,612);
            $wp_smsbox_config['customer_message_failed']   = substr(sanitize_text_field($wp_smsbox_config['customer_message_failed']),0,612);

            $wp_smsbox_config['sender_id_admin']    = substr(sanitize_text_field($wp_smsbox_config['sender_id_admin']),0,11);
            $wp_smsbox_config['sender_id_customer'] = substr(sanitize_text_field($wp_smsbox_config['sender_id_customer']),0,11);

            preg_match('/^(?![0-9\s]*$)[a-zA-Z0-9\s]+$/',$wp_smsbox_config['sender_id_admin'],$admin_sender_id);
            preg_match('/^(?![0-9\s]*$)[a-zA-Z0-9\s]+$/',$wp_smsbox_config['sender_id_customer'],$customer_sender_id);


            if((!empty($admin_sender_id) || $wp_smsbox_config['sender_id_admin']=='') && (!empty($customer_sender_id ) || $wp_smsbox_config['sender_id_customer']=='')){
                $wp_smsbox_config['admin_mobile']                       = validate_mobile_numbers($wp_smsbox_config['admin_mobile']);
                $wp_smsbox_config['smsbox_new_customer_admin_mobile']   = validate_mobile_numbers($wp_smsbox_config['smsbox_new_customer_admin_mobile']);
                update_option('wp_smsbox_username',sanitize_text_field($_POST['wp_smsbox_username']));
                update_option('wp_smsbox_password',sanitize_text_field($_POST['wp_smsbox_password']));
                update_option('wp_smsbox_config',$wp_smsbox_config);
                wp_redirect('admin.php?page=woocommerce_smsbox');
            }else{
                $error_message = 'Alphanumeric_value_are_allowed_with_sender_id';
                add_settings_error('general', 'settings_updated', $error_message, 'error');
                wp_redirect('admin.php?page=woocommerce_smsbox&error='.$error_message);
            }
        }else{
            $error_message = 'Please_enter_username_and_password';
            add_settings_error('general', 'settings_updated', $error_message, 'error');
            wp_redirect('admin.php?page=woocommerce_smsbox&error='.$error_message);
        }
    }

    function validate_mobile_numbers($admin_numbers){
        $number = '';
        $admin_numbers_arr = explode(',',$admin_numbers);
        foreach ($admin_numbers_arr as $key => $val) {
            if($val !='' && intval($val)){
                //preg_match('/^(07)[\d]{9}$/',$val,$match);
                preg_match('/^(69)[\d]{8}$/',$val,$match);
                if($match[0]!=''){
                    $number .= $match[0].',';
                }
            }
        }
        return trim($number,',');
    }

    function woocommerce_smsbox_init(){
        if(get_option( 'wp_smsbox_username' )!='' && get_option( 'wp_smsbox_password' )!=''){
            $config = array();
            $config['username'] = get_option( 'wp_smsbox_username' );
            $config['password'] = get_option( 'wp_smsbox_password' );
        }
        include_once dirname( __FILE__ ) . "/template/settings.php";
    }

    function smsbox_quick_sms_send_action() {
        global $woocommerce;
        $sender_id = get_option('wp_smsbox_config');

        $message = $_POST['message'];
        $to = $_POST['recipient'];

        $url  = 'http://www.smsbox.gr/httpapi/sendsms.php?username='.get_option('wp_smsbox_username').'&password='.get_option('wp_smsbox_password').'&to='.$to.'&from=Smsbox'.'&text='.urlencode($message).'&encoding=UTF8';

        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        $result = curl_exec($ch);
        curl_close($ch);

        wp_send_json($result);
    }
}

include_once dirname(__FILE__) . "/smsbox_config.php";
